## toil 5.12.0

=== Makefile ===
# Copyright (C) 2015-2021 Regents of the University of California
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
include common.mk

define help

Supported targets: prepare, develop, docs, sdist, clean, test, docker, and push_docker.

Please note that all build targets require a virtualenv to be active.

The 'prepare' target installs Toil's build requirements into the current virtualenv.

The 'develop' target creates an editable install of Toil and its runtime requirements in the
current virtualenv. The install is called 'editable' because changes to the source code
immediately affect the virtualenv. Set the 'extras' variable to ensure that the 'develop' target
installs support for extras; some tests require extras to be installed. Consult setup.py for the
list of supported extras. To install Toil in develop mode with all extras, run

	make develop extras=[all]

The 'sdist' target creates a source distribution of Toil. It is used for some unit tests and for
installing the currently checked out version of Toil into the appliance image.

The 'clean' target cleans up the side effects of 'develop', 'sdist', 'docs', and 'docker'
on this machine. It does not undo externally visible effects like removing packages already
uploaded to PyPI.

The 'docs' target uses Sphinx to create HTML documentation in the docs/_build directory

Targets are provided to run Toil's tests. Note that these targets do *not* automatically install
Toil's dependencies; it is recommended to 'make develop' before running any of them.

The 'test' target runs Toil's unit tests in parallel with pytest. It will run some docker tests and
setup. Note: this target does not capture output from the terminal. For any of the test targets,
set the 'tests' variable to run a particular test, e.g.

	make test tests=src/toil/test/sort/sortTest.py::SortTest::testSort
    
The 'cov' variable can be set to '' to suppress the test coverage report.
    
The 'test_offline' target is similar, but runs only tests that don't need
Internet or Docker by default.  The 'test_offline' target takes the same
arguments as the 'test' target.

    make test_offline tests=src/toil/test/src/threadingTest.py

The 'docker' target builds the Docker images that make up the Toil appliance. You may set the
TOIL_DOCKER_REGISTRY variable to override the default registry that the 'push_docker' target pushes
the appliance images to, for example:

	TOIL_DOCKER_REGISTRY=quay.io/USER make docker

You might also want to build just for one architecture and load into your
Docker daemon. We have a 'load_docker' target for this.

    make load_docker arch=amd64

If Docker is not installed, Docker-related targets tasks and tests will be skipped. The
same can be achieved by setting TOIL_DOCKER_REGISTRY to an empty string.

The 'push_docker' target pushes the Toil appliance images to a remote Docker registry. It
requires the TOIL_DOCKER_REGISTRY variable to be set to a value other than the default to avoid
accidentally pushing to the official Docker registry for Toil.

The TOIL_DOCKER_NAME environment variable can be set to customize the appliance image name that
is created by the 'docker' target and pushed by the 'push_docker' target.

endef
export help
help:
	@printf "$$help"


# This Makefile uses bash features like printf and <()
SHELL=bash
tests=src/toil/test
arch=linux/amd64,linux/arm64
cov="--cov=toil"
extras=
# You can say make develop packages=xxx to install packages in the same Python
# environment as Toil itself without creating dependency conflicts with Toil
packages=
sdist_name:=toil-$(shell python version_template.py distVersion).tar.gz

green=\033[0;32m
normal=\033[0m
red=\033[0;31m
cyan=\033[0;36m

# expression to tell pytest what tests to run based on their marks
# the empty string means all tests will be run
marker=""

develop: check_venv
	pip install -e .$(extras) $(packages)

clean_develop: check_venv
	- rm -rf src/*.egg-info
	- rm src/toil/version.py

uninstall:
	- pip uninstall -y toil

sdist: dist/$(sdist_name)

dist/$(sdist_name): check_venv
	@test -f dist/$(sdist_name) && mv dist/$(sdist_name) dist/$(sdist_name).old || true
	python setup.py sdist
	@test -f dist/$(sdist_name).old \
	    && ( cmp -s <(tar -xOzf dist/$(sdist_name)) <(tar -xOzf dist/$(sdist_name).old) \
	         && mv dist/$(sdist_name).old dist/$(sdist_name) \
	         && printf "$(cyan)No significant changes to sdist, reinstating backup.$(normal)\n" \
	         || rm dist/$(sdist_name).old ) \
	    || true

clean_sdist:
	- rm -rf dist
	- rm src/toil/version.py

# Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
test: check_venv check_build_reqs
	TOIL_OWNER_TAG="shared" \
	    python -m pytest --durations=0 --strict-markers --log-level DEBUG --log-cli-level INFO -r s $(cov) -n auto --dist loadscope $(tests) -m "$(marker)"


# This target will skip building docker and all docker based tests
# these are our travis tests; rename?
test_offline: check_venv check_build_reqs
	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
	TOIL_SKIP_DOCKER=True \
	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) -n auto --dist loadscope $(tests) -m "$(marker)"

# This target will run about 1 minute of tests, and stop at the first failure
test_1min: check_venv check_build_reqs
	TOIL_SKIP_DOCKER=True \
	    python -m pytest -vv --timeout=10 --strict-markers --log-level DEBUG --log-cli-level INFO --maxfail=1 src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::CWLWorkflowTest::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior -m "$(marker)"

ifdef TOIL_DOCKER_REGISTRY

docker_image:=$(TOIL_DOCKER_REGISTRY)/$(TOIL_DOCKER_NAME)
grafana_image:=$(TOIL_DOCKER_REGISTRY)/toil-grafana
prometheus_image:=$(TOIL_DOCKER_REGISTRY)/toil-prometheus
mtail_image:=$(TOIL_DOCKER_REGISTRY)/toil-mtail

define tag_docker
	@printf "$(cyan)Removing old tag $2. This may fail but that's expected.$(normal)\n"
	-docker rmi $2
	docker tag $1 $2
	@printf "$(green)Tagged appliance image $1 as $2.$(normal)\n"
endef

docker: toil_docker prometheus_docker grafana_docker mtail_docker

pre_pull_docker:
	# Pre-pull everything
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull ubuntu:22.04 && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull prom/prometheus:v2.24.1 && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull grafana/grafana && break || sleep 60; done
	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull sscaling/mtail && break || sleep 60; done

toil_docker: pre_pull_docker docker/Dockerfile
	mkdir -p .docker_cache
	@set -ex \
	; cd docker \
	; docker buildx build --platform=$(arch) --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(docker_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(docker_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../.docker-cache/toil --cache-to type=local,dest=../.docker-cache/toil -f Dockerfile .

prometheus_docker: pre_pull_docker
	mkdir -p .docker_cache
	@set -ex \
	; cd dashboard/prometheus \
	; docker buildx build --platform=$(arch) --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(prometheus_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(prometheus_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/prometheus --cache-to type=local,dest=../../.docker-cache/prometheus -f Dockerfile .

grafana_docker: pre_pull_docker
	mkdir -p .docker_cache
	@set -ex \
	; cd dashboard/grafana \
	; docker buildx build --platform=$(arch) --tag=$(grafana_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(grafana_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(grafana_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/grafana --cache-to type=local,dest=../../.docker-cache/grafana -f Dockerfile .

mtail_docker: pre_pull_docker
	mkdir -p .docker_cache
	@set -ex \
	; cd dashboard/mtail \
	; docker buildx build --platform=$(arch) --tag=$(mtail_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(mtail_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(mtail_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/mtail --cache-to type=local,dest=../../.docker-cache/mtail -f Dockerfile .

docker/$(sdist_name): dist/$(sdist_name)
	cp $< $@

docker/Dockerfile: docker/Dockerfile.py docker/$(sdist_name)
	_TOIL_SDIST_NAME=$(sdist_name) python docker/Dockerfile.py > $@

clean_docker:
	-rm docker/Dockerfile docker/$(sdist_name)
	-docker rmi $(docker_image):$(TOIL_DOCKER_TAG)

push_docker: docker
	# Weird if logic is so we fail if all the pushes fail.
	# We need to build from the local cache to the cache tag and again from the local cache to the real tag.
	cd docker ; \
	for i in $$(seq 1 6); do \
		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
		docker buildx build --platform $(arch) --push --tag=$(docker_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../.docker-cache/toil --cache-to type=inline -f Dockerfile . && \
			docker buildx build --platform $(arch) --push --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../.docker-cache/toil -f Dockerfile . && \
			break || sleep 60; \
	done
	cd dashboard/prometheus ; \
	for i in $$(seq 1 6); do \
		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
		docker buildx build --platform $(arch) --push --tag=$(prometheus_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/prometheus --cache-to type=inline -f Dockerfile . && \
			docker buildx build --platform $(arch) --push --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../../.docker-cache/prometheus -f Dockerfile . && \
			break || sleep 60; \
	done
	cd dashboard/grafana ; \
	for i in $$(seq 1 6); do \
		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
		docker buildx build --platform $(arch) --push --tag=$(grafana_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/grafana --cache-to type=inline -f Dockerfile . && \
			docker buildx build --platform $(arch) --push --tag=$(grafana_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../../.docker-cache/grafana -f Dockerfile . && \
			break || sleep 60; \
	done
	cd dashboard/mtail ; \
	for i in $$(seq 1 6); do \
		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
		docker buildx build --platform $(arch) --push --tag=$(mtail_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/mtail --cache-to type=inline -f Dockerfile . && \
			docker buildx build --platform $(arch) --push --tag=$(mtail_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../../.docker-cache/mtail -f Dockerfile . && \
			break || sleep 60; \
	done

load_docker: docker
	cd docker ; docker buildx build --platform $(arch) --load --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../.docker-cache/toil -f Dockerfile .

=== debian/changelog ===
toil (5.12.0-2) unstable; urgency=medium

  * d/tests/run-unit-tests: fix typo.
  * Added patch to the tests: only request a single core. Closes:
    #1031192
  * d/clean: remove docs/autoapi and another straggler. Closes: #1047298

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 22 Aug 2023 15:46:37 +0200

toil (5.12.0-1) unstable; urgency=medium

  * New upstream version
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * refreshed patches.
  * d/rules: wdltoil_test has a new path.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 21 Aug 2023 19:09:01 +0200

=== debian/control ===
Source: toil
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               python3-all:any,
               python3-setuptools,
               python3-docker,
               python3-dill,
               python3-future,
               cwltool (>= 3.1.20230601100705),
               python3-schema-salad (>= 8.4.20230128170514),
               python3-distutils,
               python3-enlighten,
               python3-wdlparse,
               python3-pytest <!nocheck>,
               python3-pytest-xdist <!nocheck>,
               python3-mock <!nocheck>,
               python3-boto3 (>=1.17) <!nocheck>,
               python3-boto <!nocheck>,
               python3-stubserver <!nocheck>,
               rsync <!nocheck>,
               python3-yaml <!nocheck>,
               docker.io <!nocheck>,
               python3-urllib3,
               python3-sphinx <!nodoc>,
               python3-sphinx-autoapi <!nodoc>,
               python3-sphinx-autodoc-typehints <!nodoc>,
               python3-sphinxcontrib.autoprogram <!nodoc>,
               python3-pubsub <!nodoc>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/toil
Vcs-Git: https://salsa.debian.org/med-team/toil.git
Homepage: https://github.com/BD2KGenomics/toil
Rules-Requires-Root: no

Package: toil
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends},
         python3-distutils,
         cwltool (>= 3.1.20221201130942),
         python3-schema-salad (>= 8.4.20230128170514),
         python3-boto,
         python3-boto3
# for google cloud support
Recommends: python3-libcloud
# for WDL support
#           python3-wdlparse,
# for mesos support, but needs python3-mesos first
#           python3-protobuf,
Suggests: podman | docker.io | singularity-container | docker-ce,
          python3-azure,
          python3-azure-storage,
          python3-idna,
Provides: cwl-runner
#Suggests: python-toil-doc
Description: cross-platform workflow engine
 Toil is a scalable, efficient, cross-platform and easy-to-use workflow
 engine in pure Python.  It works with several well established load
 balancers like Slurm or the Sun Grid Engine.  Toil is also compatible with
 the Common Workflow Language (CWL) via the "toil-cwl-runner" interface, which
 this package make available via the Debian alternativess system under the
 alias "cwl-runner".

#Package: python-toil-doc
#Architecture: all
#Section: doc
#Depends: ${sphinxdoc:Depends}, ${misc:Depends}
#Description: cross-platform workflow engine (common documentation)
# The documentation of Toil shall go here at some point.
# .
# This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PYBUILD_NAME=toil

export PYBUILD_DESTDIR_python3=debian/toil/

#export PYBUILD_DISABLE=test
export PYBUILD_DISABLE_python2=1
%:
	dh $@ --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=$(CURDIR)/src $(MAKE) -C docs man

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	PYBUILD_SYSTEM=custom \
		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -n auto --dist loadscope -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/wdltoil_test.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py --ignore src/toil/test/lib/aws/test_iam.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv or ToilDocumentationTest or test_cwl_toil_kill or testImportReadFileCompatibility or CleanWorkDirTest or DeferredFunctionTest or WdlToilTest)" {dir}/src/toil/test' \
		dh_auto_test
endif

# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#override_dh_auto_build:
#	dh_auto_build
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml docs/ build/html # HTML generator
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bman  docs/ build/man  # Manpage generator

override_dh_auto_clean:
	rm -rf .pybuild
	rm -rf docs/_build
	find . -name "*.pyc" -delete

=== debian/tests/control ===
Tests: smoke-test
Depends: toil
Restrictions: allow-stderr, superficial

Tests: run-unit-tests
Depends: toil, python3, python3-wdlparse, python3-pytest, python3-pytest-xdist, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver, python3-yaml, quilt, docker.io
Restrictions: allow-stderr, needs-internet

## toil 6.1.0

=== Makefile ===
--- 
+++ 
@@ -101,6 +101,8 @@
 # expression to tell pytest what tests to run based on their marks
 # the empty string means all tests will be run
 marker=""
+# Number of tests to run in parallel.
+threads:="auto"
 
 develop: check_venv
 	pip install -e .$(extras) $(packages)
@@ -131,7 +133,11 @@
 # Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
 test: check_venv check_build_reqs
 	TOIL_OWNER_TAG="shared" \
-	    python -m pytest --durations=0 --strict-markers --log-level DEBUG --log-cli-level INFO -r s $(cov) -n auto --dist loadscope $(tests) -m "$(marker)"
+	    python -m pytest --durations=0 --strict-markers --log-level DEBUG --log-cli-level INFO -r s $(cov) -n $(threads) --dist loadscope $(tests) -m "$(marker)"
+
+test_debug: check_venv check_build_reqs
+	TOIL_OWNER_TAG="$(whoami)" \
+	    python -m pytest --durations=0 --strict-markers --log-level DEBUG -s -o log_cli=true --log-cli-level DEBUG -r s $(tests) -m "$(marker)" --tb=native --maxfail=1
 
 
 # This target will skip building docker and all docker based tests
@@ -139,7 +145,8 @@
 test_offline: check_venv check_build_reqs
 	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
 	TOIL_SKIP_DOCKER=True \
-	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) -n auto --dist loadscope $(tests) -m "$(marker)"
+	TOIL_SKIP_ONLINE=True \
+	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) -n $(threads) --dist loadscope $(tests) -m "$(marker)"
 
 # This target will run about 1 minute of tests, and stop at the first failure
 test_1min: check_venv check_build_reqs
@@ -162,32 +169,25 @@
 
 docker: toil_docker prometheus_docker grafana_docker mtail_docker
 
-pre_pull_docker:
-	# Pre-pull everything
-	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull ubuntu:22.04 && break || sleep 60; done
-	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull prom/prometheus:v2.24.1 && break || sleep 60; done
-	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull grafana/grafana && break || sleep 60; done
-	for i in $$(seq 1 11); do if [[ $$i == "11" ]] ; then exit 1 ; fi ; docker pull sscaling/mtail && break || sleep 60; done
-
-toil_docker: pre_pull_docker docker/Dockerfile
+toil_docker: docker/Dockerfile
 	mkdir -p .docker_cache
 	@set -ex \
 	; cd docker \
 	; docker buildx build --platform=$(arch) --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(docker_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(docker_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../.docker-cache/toil --cache-to type=local,dest=../.docker-cache/toil -f Dockerfile .
 
-prometheus_docker: pre_pull_docker
+prometheus_docker:
 	mkdir -p .docker_cache
 	@set -ex \
 	; cd dashboard/prometheus \
 	; docker buildx build --platform=$(arch) --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(prometheus_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(prometheus_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/prometheus --cache-to type=local,dest=../../.docker-cache/prometheus -f Dockerfile .
 
-grafana_docker: pre_pull_docker
+grafana_docker:
 	mkdir -p .docker_cache
 	@set -ex \
 	; cd dashboard/grafana \
 	; docker buildx build --platform=$(arch) --tag=$(grafana_image):$(TOIL_DOCKER_TAG) --cache-from type=registry,ref=$(grafana_image):$(TOIL_DOCKER_MAIN_CACHE_TAG) --cache-from type=registry,ref=$(grafana_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/grafana --cache-to type=local,dest=../../.docker-cache/grafana -f Dockerfile .
 
-mtail_docker: pre_pull_docker
+mtail_docker:
 	mkdir -p .docker_cache
 	@set -ex \
 	; cd dashboard/mtail \
@@ -237,3 +237,4 @@
 
 load_docker: docker
 	cd docker ; docker buildx build --platform $(arch) --load --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../.docker-cache/toil -f Dockerfile .
+	cd dashboard/prometheus ; docker buildx build --platform $(arch) --load --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../../.docker-cache/prometheus -f Dockerfile .

=== requirements.txt ===
dill>=0.3.2, <0.4
requests>=2, <3
docker>=6.1.0, <8
# Work around https://github.com/docker/docker-py/issues/3113
urllib3>=1.26.0,<3
python-dateutil
psutil >= 3.0.1, <6
PyPubSub >=4.0.3, <5
addict>=2.2.1, <2.5
pytz>=2012
enlighten>=1.5.2, <2
configargparse>=1.7,<2
ruamel.yaml>=0.15
pyyaml>=6,<7
typing-extensions>=4.6.2, <5

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -W --keep-going
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
toil (6.1.0-4) unstable; urgency=medium

  * d/control: we now need an explicit dependency on python3-tz. Closes:
    #1070055

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 29 Apr 2024 16:41:47 +0200

toil (6.1.0-3) unstable; urgency=medium

  * d/README.source: make more explicit the need to follow the
    instructions in debian/patch/settings_version.patch on every new
    source tarball.
  * d/control: drop unneeded dependency on python3-distutils.
    Closes: #1065987

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 11 Mar 2024 12:14:38 +0100

toil (6.1.0-2) unstable; urgency=medium

  * d/control: azure support is gone, don't suggest it anymore.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 28 Feb 2024 15:20:36 +0100

toil (6.1.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Run test for all supported Python versions
  * Do not force any specific docker version, just take the Debian
    packaged one

  [ Michael R. Crusoe ]
  * d/patches/setting_version.patch: regenerate according to the
    intructions in d/README.source.
  * d/tests/run-unit-tests: two more tests need skipping.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 28 Feb 2024 11:42:03 +0100

toil (6.0.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
    Closes: #1058195
  * Drop python3-future from Build-Depends
    Closes: #1059945
  * Drop python3-boto from (Build-/Test-)Depends since upstream considers
    this module optional (see
     https://github.com/DataBiosphere/toil/issues/4718#issuecomment-1904474636
    )
    Closes: #1058237
  * Build-Depends: python3-configargparse
  * Soften versioned dependency from cwltool

  [ Michael R. Crusoe ]
  * d/rules,d/control, d/patches/intersphinx: Fix some sphinx warnings, ignore
                                              the rest.
  * Add patch to avoid need for ruamel.yaml.string package.
  * Add patch to allow for older configarparser version.
  * Ignore the new test_cactus_integration
  * Enhance avoid_boto patch
  * d/patches: updated metatdata
  * d/copyright: upstream removed wdl_functions.py
  * Add patch to remove use of distutils by copying in strtobool().
  * d/control: bump some minimum versions

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 23 Jan 2024 15:24:30 +0100

=== debian/control ===
--- 
+++ 
@@ -8,19 +8,16 @@
                dh-sequence-python3,
                python3-all:any,
                python3-setuptools,
+               python3-configargparse,
                python3-docker,
                python3-dill,
-               python3-future,
-               cwltool (>= 3.1.20230601100705),
+               cwltool (>= 3.1.20240112164112),
                python3-schema-salad (>= 8.4.20230128170514),
-               python3-distutils,
                python3-enlighten,
                python3-wdlparse,
                python3-pytest <!nocheck>,
                python3-pytest-xdist <!nocheck>,
-               python3-mock <!nocheck>,
                python3-boto3 (>=1.17) <!nocheck>,
-               python3-boto <!nocheck>,
                python3-stubserver <!nocheck>,
                rsync <!nocheck>,
                python3-yaml <!nocheck>,
@@ -30,7 +27,9 @@
                python3-sphinx-autoapi <!nodoc>,
                python3-sphinx-autodoc-typehints <!nodoc>,
                python3-sphinxcontrib.autoprogram <!nodoc>,
-               python3-pubsub <!nodoc>
+               python3-pubsub <!nodoc>,
+               python3-doc <!nodoc>,
+               python3-tz <!nodoc> <!nocheck>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
@@ -41,20 +40,13 @@
 Architecture: all
 Depends: ${python3:Depends},
          ${misc:Depends},
-         python3-distutils,
-         cwltool (>= 3.1.20221201130942),
+         cwltool (>= 3.1.20240112164112),
          python3-schema-salad (>= 8.4.20230128170514),
-         python3-boto,
          python3-boto3
-# for google cloud support
 Recommends: python3-libcloud
-# for WDL support
-#           python3-wdlparse,
 # for mesos support, but needs python3-mesos first
 #           python3-protobuf,
 Suggests: podman | docker.io | singularity-container | docker-ce,
-          python3-azure,
-          python3-azure-storage,
           python3-idna,
 Provides: cwl-runner
 #Suggests: python-toil-doc

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export PYBUILD_NAME=toil

export PYBUILD_DESTDIR_python3=debian/toil/

#export PYBUILD_DISABLE=test
export PYBUILD_DISABLE_python2=1
%:
	dh $@ --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=$(CURDIR)/src $(MAKE) -C docs man SPHINXOPTS=""

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	PYBUILD_SYSTEM=custom \
		PYBUILD_TEST_ARGS='HOME={home_dir} {interpreter} setup.py develop --user && PYTHONPATH={dir}/src:$$PYTHONPATH PATH={home_dir}/.local/bin/:$$PATH TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True {interpreter} -m pytest -n auto --dist loadscope -vv -W ignore --ignore src/toil/test/lib/aws/test_s3.py --ignore src/toil/test/provisioners/aws/awsProvisionerTest.py --ignore src/toil/test/wdl/wdltoil_test.py --ignore src/toil/test/cwl/cwlTest.py --ignore src/toil/test/src/promisedRequirementTest.py --ignore src/toil/test/lib/test_ec2.py --ignore src/toil/test/batchSystems/batchSystemTest.py --ignore src/toil/test/lib/aws/test_iam.py -k "not (test_bioconda or test_run_conformance or testImportFtpFile or ToilWdlIntegrationTest or SortTest or testCwlexample or testVirtualEnv or ToilDocumentationTest or test_cwl_toil_kill or testImportReadFileCompatibility or CleanWorkDirTest or DeferredFunctionTest or WdlToilTest or test_cactus_integration)" {dir}/src/toil/test' \
		dh_auto_test
endif

# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#override_dh_auto_build:
#	dh_auto_build
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bhtml docs/ build/html # HTML generator
#	PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -N -bman  docs/ build/man  # Manpage generator

override_dh_auto_clean:
	rm -rf .pybuild
	rm -rf docs/_build
	find . -name "*.pyc" -delete

## toil 8.0.0

=== Makefile ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 define help
 
-Supported targets: prepare, develop, docs, sdist, clean, test, docker, and push_docker.
+Supported targets: prepare, develop, docs, dist, clean, test, docker, and push_docker.
 
 Please note that all build targets require a virtualenv to be active.
 
@@ -29,10 +29,11 @@
 
 	make develop extras=[all]
 
-The 'sdist' target creates a source distribution of Toil. It is used for some unit tests and for
-installing the currently checked out version of Toil into the appliance image.
-
-The 'clean' target cleans up the side effects of 'develop', 'sdist', 'docs', and 'docker'
+The 'dist' target creates a source distribution and a wheel of Toil. It is used
+for some unit tests and for installing the currently checked out version of Toil
+into the appliance image.
+
+The 'clean' target cleans up the side effects of 'develop', 'dist', 'docs', and 'docker'
 on this machine. It does not undo externally visible effects like removing packages already
 uploaded to PyPI.
 
@@ -91,7 +92,7 @@
 # You can say make develop packages=xxx to install packages in the same Python
 # environment as Toil itself without creating dependency conflicts with Toil
 packages=
-sdist_name:=toil-$(shell python version_template.py distVersion).tar.gz
+sdist_name:=toil-$(shell python3 version_template.py distVersion).tar.gz
 
 green=\033[0;32m
 normal=\033[0m
@@ -104,6 +105,18 @@
 # Number of tests to run in parallel.
 threads:="auto"
 
+# Only pass the threading options if running parallel tests. Otherwise we lose
+# live logging. See <https://stackoverflow.com/q/62533239>
+ifeq "$(threads)" "auto"
+	threadopts=-n $(threads) --dist loadscope
+else
+ifeq "$(threads)" "1"
+	threadopts=
+else
+	threadopts=-n $(threads) --dist loadscope
+endif
+endif
+
 develop: check_venv
 	pip install -e .$(extras) $(packages)
 
@@ -114,11 +127,12 @@
 uninstall:
 	- pip uninstall -y toil
 
+dist: sdist
 sdist: dist/$(sdist_name)
 
-dist/$(sdist_name): check_venv
+dist/$(sdist_name):
 	@test -f dist/$(sdist_name) && mv dist/$(sdist_name) dist/$(sdist_name).old || true
-	python setup.py sdist
+	python3 -m build
 	@test -f dist/$(sdist_name).old \
 	    && ( cmp -s <(tar -xOzf dist/$(sdist_name)) <(tar -xOzf dist/$(sdist_name).old) \
 	         && mv dist/$(sdist_name).old dist/$(sdist_name) \
@@ -133,11 +147,11 @@
 # Setting SET_OWNER_TAG will tag cloud resources so that UCSC's cloud murder bot won't kill them.
 test: check_venv check_build_reqs
 	TOIL_OWNER_TAG="shared" \
-	    python -m pytest --durations=0 --strict-markers --log-level DEBUG --log-cli-level INFO -r s $(cov) -n $(threads) --dist loadscope $(tests) -m "$(marker)"
+	    python -m pytest --log-format="%(asctime)s %(levelname)s %(message)s" --durations=0 --strict-markers --log-level DEBUG -o log_cli=true --log-cli-level INFO -r s $(cov) $(threadopts) $(tests) -m "$(marker)" --color=yes
 
 test_debug: check_venv check_build_reqs
 	TOIL_OWNER_TAG="$(whoami)" \
-	    python -m pytest --durations=0 --strict-markers --log-level DEBUG -s -o log_cli=true --log-cli-level DEBUG -r s $(tests) -m "$(marker)" --tb=native --maxfail=1
+	    python -m pytest --log-format="%(asctime)s %(levelname)s %(message)s" --durations=0 --strict-markers --log-level DEBUG -s -o log_cli=true --log-cli-level DEBUG -r s $(tests) -m "$(marker)" --tb=native --maxfail=1 --color=yes
 
 
 # This target will skip building docker and all docker based tests
@@ -146,12 +160,12 @@
 	@printf "$(cyan)All docker related tests will be skipped.$(normal)\n"
 	TOIL_SKIP_DOCKER=True \
 	TOIL_SKIP_ONLINE=True \
-	    python -m pytest -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) -n $(threads) --dist loadscope $(tests) -m "$(marker)"
+	    python -m pytest --log-format="%(asctime)s %(levelname)s %(message)s" -vv --timeout=600 --strict-markers --log-level DEBUG --log-cli-level INFO $(cov) -n $(threads) --dist loadscope $(tests) -m "$(marker)" --color=yes
 
 # This target will run about 1 minute of tests, and stop at the first failure
 test_1min: check_venv check_build_reqs
 	TOIL_SKIP_DOCKER=True \
-	    python -m pytest -vv --timeout=10 --strict-markers --log-level DEBUG --log-cli-level INFO --maxfail=1 src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::CWLWorkflowTest::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior -m "$(marker)"
+	    python -m pytest --log-format="%(asctime)s %(levelname)s %(message)s" -vv --timeout=10 --strict-markers --log-level DEBUG --log-cli-level INFO --maxfail=1 src/toil/test/batchSystems/batchSystemTest.py::SingleMachineBatchSystemTest::test_run_jobs src/toil/test/batchSystems/batchSystemTest.py::KubernetesBatchSystemBenchTest src/toil/test/server/serverTest.py::ToilWESServerBenchTest::test_get_service_info src/toil/test/cwl/cwlTest.py::CWLWorkflowTest::test_run_colon_output src/toil/test/jobStores/jobStoreTest.py::FileJobStoreTest::testUpdateBehavior -m "$(marker)" --color=yes
 
 ifdef TOIL_DOCKER_REGISTRY
 
@@ -232,9 +246,3 @@
 		if [[ $$i == "6" ]] ; then exit 1 ; fi ; \
 		docker buildx build --platform $(arch) --push --tag=$(mtail_image):$(TOIL_DOCKER_CACHE_TAG) --cache-from type=local,src=../../.docker-cache/mtail --cache-to type=inline -f Dockerfile . && \
 			docker buildx build --platform $(arch) --push --tag=$(mtail_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../../.docker-cache/mtail -f Dockerfile . && \
-			break || sleep 60; \
-	done
-
-load_docker: docker
-	cd docker ; docker buildx build --platform $(arch) --load --tag=$(docker_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../.docker-cache/toil -f Dockerfile .
-	cd dashboard/prometheus ; docker buildx build --platform $(arch) --load --tag=$(prometheus_image):$(TOIL_DOCKER_TAG) --cache-from type=local,src=../../.docker-cache/prometheus -f Dockerfile .

=== requirements.txt ===
dill>=0.3.2, <0.4
requests<=2.31.0
docker>=6.1.0, <8
urllib3>=1.26.0,<3
python-dateutil
psutil >= 6.1.0, < 7
PyPubSub >=4.0.3, <5
addict>=2.2.1, <2.5
backports.zoneinfo[tzdata];python_version<"3.9"
enlighten>=1.5.2, <2
configargparse>=1.7,<2
ruamel.yaml>=0.15
pyyaml>=6,<7
typing-extensions>=4.6.2, <5
coloredlogs>=15,<16

=== debian/changelog ===
toil (8.0.0-5) unstable; urgency=medium

  * d/rules: skip flaky testServices. Closes: #1101085

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Apr 2025 13:42:27 +0200

toil (8.0.0-4) unstable; urgency=medium

  * d/rules: skip the slow tests
  * d/patches/needs_aws-proxyfix: forwarded upstream

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 21 Mar 2025 17:28:28 +0100

toil (8.0.0-3) unstable; urgency=medium

  * d/tests/autopkgtest-pkg-pybuild.conf: fix typo

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Mar 2025 18:39:08 +0100

toil (8.0.0-2) unstable; urgency=medium

  * d/watch: mark beta releases as such
  * Skip autopktests on 32-bit architectures
  * d/rules: skip the testMultiplejobs tests, they are flaky during
    parallel execution. Closes: #1100817

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Mar 2025 12:41:12 +0100

toil (8.0.0-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * New upstream version
  * Refresh patches
  * d/patches/allow_newer_requests: added
  * docs: link to cwltool-doc; link to python3-doc locally
  * d/patches/skip-mypy-boto3: these type hints are not packaged for
    Debian yet
  * d/patches/needs_aws-proxyfix: Fix build due to purposely invalid
    proxy configuration.
  * d/rules: skip online tests
  * d/patches/setting_version.patch: update for Python 3.12
  * d/rules: use DEB_BUILD_OPTION_PARALLEL instead of "auto" for setting
    the amount of parallel testing.
  * Refreshed patches; removed "skip-mypy-boto3" and "python3.12-
    syntax.patch" as they are no longer needed.
  * Added patch to remove the restrictions on the psutil Python package
    version.
  * Updated the fix-tests patch to fix more tests.
  * d/control: cwl-utils is needed for the tests
  * Added patch with a minimal PEP-517 pyproject.toml, to improve how we
    run the tests.
  * d/rules: simplify
  * d/rules: skip manual page building in when the "nodoc" build profile
    is active.
  * Switch autopkgtest to autopkgtest-pkg-pybuild
  * d/TODO: removed several completed items.
  * d/toil.lintian-overrides: removed, no longer applicable
  * d/patches/soften-configargparser-deps: removed, no longed needed

  [ Andreas Tille ]
  * Fix Python3.12 string syntax
    Closes: #1087116
  * Standards-Version: 4.7.0 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 18 Mar 2025 17:34:39 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,10 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
+               pybuild-plugin-pyproject,
                python3-all:any,
                python3-setuptools,
+               python3-setuptools-scm,
                python3-configargparse,
                python3-docker,
                python3-dill,
@@ -23,18 +25,21 @@
                python3-yaml <!nocheck>,
                docker.io <!nocheck>,
                python3-urllib3,
+               cwltool-doc <!nodoc>,
                python3-sphinx <!nodoc>,
                python3-sphinx-autoapi <!nodoc>,
                python3-sphinx-autodoc-typehints <!nodoc>,
                python3-sphinxcontrib.autoprogram <!nodoc>,
                python3-pubsub <!nodoc>,
                python3-doc <!nodoc>,
-               python3-tz <!nodoc> <!nocheck>
-Standards-Version: 4.6.2
+               python3-tz <!nodoc> <!nocheck>,
+               cwl-utils <!nocheck>
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
 Homepage: https://github.com/BD2KGenomics/toil
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: toil
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export PYBUILD_NAME=toil

export PYBUILD_DESTDIR_python3=debian/toil/
PYBUILD_TEST_ARGS=$(DEB_BUILD_OPTION_PARALLEL:%=-n %) --dist loadscope -vv -W ignore  -k "not (testVirtualEnv or DockstoreLookupTest or testMultiplejobs or testServices)" -m "not slow"
# testVirtualEnv - requires an internet connection to download packages from PyPI
# testMultiplejobs - flaky during parallel execution
# testServices - flaky during parallel execution https://bugs.debian.org/1101085
ifeq ($(PYBUILD_AUTOPKGTEST),1)
PYBUILD_TEST_ARGS += --ignore /usr/lib/python3/dist-packages/toil/test/lib/aws/test_s3.py --ignore /usr/lib/python3/dist-packages/toil/test/provisioners/aws/awsProvisionerTest.py --ignore /usr/lib/python3/dist-packages/toil/test/wdl/wdltoil_test.py --ignore /usr/lib/python3/dist-packages/toil/test/cwl/cwlTest.py --ignore /usr/lib/python3/dist-packages/toil/test/lib/test_ec2.py --ignore /usr/lib/python3/dist-packages/toil/test/batchSystems/batchSystemTest.py --ignore /usr/lib/python3/dist-packages/toil/test/lib/aws/test_iam.py --ignore  /usr/lib/python3/dist-packages/toil/test/provisioners/clusterTest.py --ignore /usr/lib/python3/dist-packages/toil/test/wdl/wdltoil_test_kubernetes.py --ignore /usr/lib/python3/dist-packages/toil/test/cactus/test_cactus_integration.py --pyargs toil.test
else
PYBUILD_TEST_ARGS += --ignore toil/test/lib/aws/test_s3.py --ignore toil/test/provisioners/aws/awsProvisionerTest.py --ignore toil/test/wdl/wdltoil_test.py --ignore toil/test/cwl/cwlTest.py --ignore toil/test/lib/test_ec2.py --ignore toil/test/batchSystems/batchSystemTest.py --ignore toil/test/lib/aws/test_iam.py --ignore  toil/test/provisioners/clusterTest.py --ignore toil/test/wdl/wdltoil_test_kubernetes.py --ignore toil/test/cactus/test_cactus_integration.py toil/test
export PYBUILD_AFTER_TEST=find {build_dir} \( -name fileToSort.txt -o -name sortedFile.txt -o -name 'kind-explode_*' \) -print -delete ; find {build_dir} -name "jobstore-test*" | xargs rm -Rf
endif
export PYBUILD_TEST_ARGS

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_build:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	PYTHONPATH=$(CURDIR)/src http_proxy='127.0.0.1:9' $(MAKE) -C docs man SPHINXOPTS=""
endif
# If you need to rebuild the Sphinx documentation
# Add spinxdoc to the dh --with line
#	PYTHONPATH=$(CURDIR)/src http_proxy='127.0.0.1:9' $(MAKE) -C docs html # HTML generator

execute_after_dh_auto_install:
	find $(CURDIR)/debian -name cwltoil -delete
	# remove the below once mesos is packaged and tested
	find $(CURDIR)/debian -name _toil_mesos_executor -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	TOIL_SKIP_ONLINE=true TOIL_TEST_QUICK=True TOIL_SKIP_DOCKER=True dh_auto_test
endif

execute_after_dh_auto_clean:
	rm -rf docs/_build
	find . -name "*.pyc" -delete
